﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Common;
using System.Data.Entity;
using System.Data.Entity.Spatial;
using System.Text;

namespace DevartSharpMapDemo {

  public abstract class Model : DbContext {

    protected Model(DbConnection connection)
      : base(connection, true) {
    }

    protected override void OnModelCreating(DbModelBuilder modelBuilder) {
    }

    public DbSet<Region> Regions { get; set; }

    public DbSet<City> Cities { get; set; }

  }

  public class Region {

    [DatabaseGenerated(DatabaseGeneratedOption.None)]
    public int Id { get; set; }

    public DbGeography Geometry { get; set; }

  }

  public class City {

    [DatabaseGenerated(DatabaseGeneratedOption.None)]
    public int Id { get; set; }

    public DbGeography Geometry { get; set; }

    [MaxLength(200)]
    public string Name { get; set; }

  }

}
