﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity;
using System.Data.Entity.Spatial;
using System.Text;
using Devart.Data.MySql;
using Devart.Data.MySql.Entity.Configuration;

namespace DevartSharpMapDemo {

  [DbConfigurationType(typeof(Devart.Data.MySql.Entity.MySqlEntityProviderServicesConfiguration))]
  public class MySqlModel : Model {

    public MySqlModel()
       : base(new MySqlConnection("User Id=_; Password=_;Host=_;Port=_;Database=_;license key=_;")) {
    }

    static MySqlModel() {

      var config = MySqlEntityProviderConfig.Instance;

      config.SpatialOptions.SpatialServiceType = SpatialServiceType.NetTopologySuiteSigned;
      config.SpatialOptions.GeographyDistanceUnit = DistanceMeasurementUnit.Kilometer;
      //config.SpatialOptions.AlwaysUseGeometryDefaultSrid = true;
      //config.SpatialOptions.AlwaysUseGeographyDefaultSrid = true;

      config.Workarounds.DisableQuoting = true;

      Database.SetInitializer<MySqlModel>(null);
    }

    protected override void OnModelCreating(DbModelBuilder modelBuilder) {
    }

  }

}
