﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity;
using System.Data.Entity.Spatial;
using System.Text;
using Devart.Data.Oracle;
using Devart.Data.Oracle.Entity.Configuration;

namespace DevartSharpMapDemo {

  [DbConfigurationType(typeof(Devart.Data.Oracle.Entity.OracleEntityProviderServicesConfiguration))]
  public class OracleModel : Model {

    public OracleModel()
      : base(new OracleConnection("User Id=_;Password=_;Server=_;license key=_;")) {
    }

    static OracleModel() {

      var config = OracleEntityProviderConfig.Instance;

      config.SpatialOptions.SpatialServiceType = SpatialServiceType.NetTopologySuiteSigned;
      config.SpatialOptions.GeographyDistanceUnit = DistanceMeasurementUnit.Kilometer;
      config.SpatialOptions.GeographyAreaUnit = AreaMeasurementUnit.SquareKilometer;
      //config.SpatialOptions.AlwaysUseGeometryDefaultSrid = true;
      //config.SpatialOptions.AlwaysUseGeographyDefaultSrid = true;

      config.Workarounds.DisableQuoting = true;

      Database.SetInitializer<OracleModel>(null);
    }

    protected override void OnModelCreating(DbModelBuilder modelBuilder) {

      //modelBuilder
      //  .Properties()
      //  .Where(p => p.DeclaringType == typeof(string))
      //  .Configure(p => p.IsUnicode(false));
    }

  }

}
