﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity;
using System.Data.Entity.Spatial;
using System.Text;
using Devart.Data.PostgreSql;
using Devart.Data.PostgreSql.Entity.Configuration;

namespace DevartSharpMapDemo {

  [DbConfigurationType(typeof(Devart.Data.PostgreSql.Entity.PgSqlEntityProviderServicesConfiguration))]
  public class PgSqlModel : Model {

    public PgSqlModel()
      : base(new PgSqlConnection("User Id=_;Password=_;Host=_;Port=_;Database=_;license key=_;")) {
    }

    static PgSqlModel() {

      var config = PgSqlEntityProviderConfig.Instance;

      config.SpatialOptions.SpatialServiceType = SpatialServiceType.NetTopologySuiteSigned;
      config.SpatialOptions.GeographyDistanceUnit = DistanceMeasurementUnit.Kilometer;
      config.SpatialOptions.GeographyAreaUnit = AreaMeasurementUnit.SquareKilometer;
      //config.SpatialOptions.UseGeographySpheroidMeasurement = false;
      //config.SpatialOptions.AlwaysUseGeometryDefaultSrid = true;
      //config.SpatialOptions.AlwaysUseGeographyDefaultSrid = true;      

      config.Workarounds.DisableQuoting = true;

      Database.SetInitializer<PgSqlModel>(null);
    }

    protected override void OnModelCreating(DbModelBuilder modelBuilder) {
    }

  }

}
